package test;

import java.awt.Image;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.HashSet;

import com.goldencode.p2j.ui.client.gui.driver.PaintPrimitives;
import com.goldencode.p2j.ui.client.gui.driver.PaintStructure;

public class DrawImageOp
{

   private final VirtualScreen virtualScreen;

   private final HashSet<byte[]> loadedImages;
   /**
    * 
    * @param virtualScreen
    */
   public DrawImageOp(VirtualScreen virtualScreen)
   {
      this.virtualScreen = virtualScreen;
      this.loadedImages = new HashSet<byte[]>();
   }

   public byte[] execute(PaintStructure ps) {
      int x = ps.xOffset;//4
      int y = ps.yOffset;//4
      Image image = (Image) ps.img.getImage();
      int width = image.getWidth(null);//4
      int height = image.getHeight(null);//4
      final byte[] md5ImageHash = virtualScreen.drawImage(image, x, y);
      ImageEncoding encoding;
      if (!loadedImages.contains(md5ImageHash)) {
         loadedImages.add(md5ImageHash);
         encoding = ImageEncoding.Raw;
      } else {
         encoding = ImageEncoding.Md5Hash;
      }
      final byte[] encodedImage = new RawEncoder().packToBinaries(virtualScreen, x, y, width, height);
      ByteArrayOutputStream messageBuffer = new ByteArrayOutputStream(16*1024);
      try(DataOutputStream objectStream = new DataOutputStream(messageBuffer))
      {
         objectStream.writeByte(PaintPrimitives.DRAW_IMAGE.ordinal());
         objectStream.writeInt(x);
         objectStream.writeInt(y);
         objectStream.writeInt(width);
         objectStream.writeInt(height);
         if (encoding == ImageEncoding.Raw) {
            objectStream.writeInt(0);//16xU8
         } else {
            objectStream.writeInt(1);
         }
         objectStream.write(md5ImageHash);//16xU8
         if (encoding == ImageEncoding.Raw) {
            objectStream.write(encodedImage);
         }
         objectStream.close();
      }
      catch (IOException e)
      {
         e.printStackTrace();
      }
      
      return messageBuffer.toByteArray();
   }
}
