package test;

import org.eclipse.jetty.server.Server;
import org.eclipse.jetty.server.handler.ContextHandler;
import org.eclipse.jetty.server.handler.ContextHandlerCollection;
import org.eclipse.jetty.servlet.ServletContextHandler;
import org.eclipse.jetty.servlet.ServletHolder;
import org.eclipse.jetty.websocket.servlet.WebSocketServlet;
import org.eclipse.jetty.websocket.servlet.WebSocketServletFactory;

import com.goldencode.p2j.web.HtmlResourceHandler;

public class TestServer
{

   static class ImageServlet extends WebSocketServlet {

      private final Class<?> webSocket;
      
      public ImageServlet(Class<?> webSocket)
      {
         this.webSocket = webSocket;
      }

      @Override
      public void configure(WebSocketServletFactory factory)
      {
         factory.register(webSocket);
      }
      
   }
   
   public static void main(String[] args)
   {
      Server jettyWebServer = new Server(9321);
      
      HtmlResourceHandler resourceHandler = new HtmlResourceHandler("/", "/index.html");
      ContextHandler rootHandler = new ContextHandler("/");
      rootHandler.setHandler(resourceHandler);
      
      ContextHandlerCollection contexts = new ContextHandlerCollection();
      contexts.addHandler(rootHandler);

      ImageServlet imageServlet = new ImageServlet(ImageTransferProtocol.class);
      ServletContextHandler servletContext = new ServletContextHandler();
      servletContext.addServlet(new ServletHolder(imageServlet), "/getImage");
      contexts.addHandler(servletContext);

      jettyWebServer.setHandler(contexts);

      try
      {
         jettyWebServer.start();
         jettyWebServer.join();
      }
      catch (Exception e)
      {
         e.printStackTrace();
      }
      

   }

}
